skillTimers={	}

nextCastTime = getTime();


--Skills structure used to parse DOBotConfig into by state.
-- The 3 states involving skills are Attack, Rest and Buf.
-- Use these sub table to itterate through the skills for those states.
skills={
	["Attack"]		={},
	["Rest"]			={},
	["Buf"]				={}
}

mobs = nil;

Mobs = class(function(mobList,l)
	mobList.list = l;
	mobList.check = false;
	if(string.len(l:gsub("^%s*(.-)%s*$", "%1"))>0)then
		mobList.check = true;
	end
end)


function Mobs:AttackThis(mobName)
	if((self.check==false) or (string.find(self.list,mobName) ~= nil))then
		return true;
	else
		return false;
	end
end

-- initialize skills on resume.
function Initialize()
	-- reset Skills no nothing and reload "skillsConfig.cfg"
	skills={
		["Attack"]		={},
		["Rest"]			={},
		["Buf"]				={}
	}

  InitializeSkills();

end
atResume( Initialize );

-- callback to help sort skills based on priority.
-- Skills are sorted by largest first, thus a priority of
-- 100 will be itterated through first.
function skillSort(skill1,skill2)
	if(skill1["Priority"] > skill2["Priority"])then
		return true;
	else
		return false;
	end
end

-- Initialize Skills
-- This function parses the DoBotConfig.xml into a LUA table structure usable by cast skill.
-- It will also initialize the skilltimers.cfg on first run.
-- skilltimers.cfg keeps track of all skill coodowns.  It is saved after each skill cast to store cooldown state.
function InitializeSkills()
	-- cooldown skill state.
	skillTimers = table.load("./scripts/skillTimers.cfg")
	if(skillTimers == nil) then
		skillTimers={	}
	end
	-- Use the DOBotConfig to configure your skills
	-- This parses the xml into LUA table structures.
	-- duplicating skills if necessary by skill state.  (Attack, Rest, Buf)
	config = xml.open("./scripts/DOBotConfig.xml");
	elements = config:getElements("Player");
	ePlayer = nil;
	for i,v in pairs(elements) do
		if(v:getAttribute("name")==playerInfo.Name())then
			ePlayer = v;
			print(v:getAttribute("name"));
			break;
		end
	end
	-- If you know where to get the max health VIA memory reading, this
	-- can be removed and initialized elswhere via the memory read.
	-- If you do so, you may want to hide the section for these fields in 
	-- the dobotconfig.exe.  To do so..  open the DoBotConfig.exe.config and 
	if(ePlayer:getElement("MobNames"):getValue()==nil)then
		mobs = Mobs("");
	else
		ms = ePlayer:getElement("MobNames"):getValue():gsub("^%s*(.-)%s*$", "%1");
		mobs = Mobs(ms);
	end
	


	elements = ePlayer:getElement("Skills"):getElements("Skill");
	for i,v in pairs(elements) do
		s={
		["name"]										= v:getAttribute("name"):gsub("^%s*(.-)%s*$", "%1"),
		["Enabled"]            			= Lookup[v:getElement("Enabled"):getValue():gsub("^%s*(.-)%s*$", "%1")],
		["CoolDownSecs"]            = v:getElement("CoolDownSecs"):getValue(),
		["CastTime"]                = v:getElement("CastTime"):getValue(),
		["Priority"]                = v:getElement("Priority"):getValue(),
		["Vkey"]                    = Lookup[v:getElement("Vkey"):getValue():gsub("^%s*(.-)%s*$", "%1")],
		["KeyModifyer"]             = Lookup[v:getElement("KeyModifyer"):getValue():gsub("^%s*(.-)%s*$", "%1")],
		["CastBelowHealth"]         = v:getElement("CastBelowHealth"):getValue(),
		["CastBelowMana"]           = v:getElement("CastBelowMana"):getValue(),
		["CastBelowRage"]           = v:getElement("CastBelowRage"):getValue(),
		["CastAboveHealth"]         = v:getElement("CastAboveHealth"):getValue(),
		["CastAboveMana"]           = v:getElement("CastAboveMana"):getValue(),
		["CastAboveRage"]           = v:getElement("CastAboveRage"):getValue(),
		["CastBelowTargetHealth"]   = v:getElement("CastBelowTargetHealth"):getValue(),
		["CastAboveTargetHealth"]   = v:getElement("CastAboveTargetHealth"):getValue(),
		["CausesGDC"]               = v:getElement("CausesGDC"):getValue(),
		["ObeysGDC"]                = Lookup[v:getElement("ObeysGDC"):getValue():gsub("^%s*(.-)%s*$", "%1")],
		["Channeled"]               = Lookup[v:getElement("Channeled"):getValue():gsub("^%s*(.-)%s*$", "%1")],
		["CastBelowPetHealth"]      = v:getElement("CastBelowPetHealth"):getValue(),
		["CastAbovePetHealth"]      = v:getElement("CastAbovePetHealth"):getValue(),
		["SelfCast"]                = Lookup[v:getElement("SelfCast"):getValue():gsub("^%s*(.-)%s*$", "%1")],
		["TargetBuf"]               = v:getElement("TargetBuf"):getValue():gsub("^%s*(.-)%s*$", "%1"),
		["TargetBufHasNot"]         = Lookup[v:getElement("TargetBuf"):getAttribute("hasnot"):gsub("^%s*(.-)%s*$", "%1")],
		["PlayerBuf"]               = v:getElement("PlayerBuf"):getValue():gsub("^%s*(.-)%s*$", "%1"),
		["PlayerBufHasNot"]         = Lookup[v:getElement("PlayerBuf"):getAttribute("hasnot"):gsub("^%s*(.-)%s*$", "%1")],
		}
		
		s["ValidatePlayer"] = not ((s["CastBelowHealth"]         == 1)
												and  (s["CastBelowMana"]           == 1)
												and  (s["CastBelowRage"]           == 1)
												and  (s["CastAboveHealth"]         == 0)
												and  (s["CastAboveMana"]           == 0)
												and  (s["CastAboveRage"]           == 0));
												
		s["ValidatePet"] 		=  not ((s["CastBelowPetHealth"]      == 1)
												and  (s["CastAbovePetHealth"]      == 0));

		s["ValidateTarget"] = not ((s["CastBelowTargetHealth"]   == 1)
												and  (s["CastAboveTargetHealth"]   == 0));
												
												
		states = v:getElement("States"):getElements("State");
		for x,st in pairs(states) do
			table.insert(skills[st:getValue()],s);
			if(st:getValue()=="Rest")then
				if(s["CastBelowHealth"] < playerInfo["restHealth"])then
					playerInfo["restHealth"] = s["CastBelowHealth"];
				end
				
				if(s["CastBelowMana"] < playerInfo["restMana"])then
					playerInfo["restMana"] = s["CastBelowMana"];
				end
			end
		end
	
		-- initialize cooldown timer if it doesn't exist.  Leave it alone otherwise.
		-- The purpose of this is for stopping and starting the bot.  Cooldowns
		-- Are remember this way even after exiting micromacro or your bot.
		if(skillTimers[s["name"]] == nil)then
			skillTimers[s["name"]] = 0
		end		
	end					
	
	-- Sort priority highest first.
	for x,skillTable in pairs(skills) do
		table.sort(skillTable,skillSort);
	end
	-- save the skilltimers config.
	table.save( skillTimers, "./scripts/skillTimers.cfg" )
	table.save( skills, "./scripts/sortedSkills.log" )
end


--  required tables and functions to make this work correctly.
--  
--playerInfo = {
--	["state"]  = "Rest",
--	["restHealth"] = .5,
--	["restMana"] = .5,
--		
--		return % health
--		Health = function ()
--		end,
--		
--		return % mana
--		Mana = function ()
--		end,
--		
--		return % rage
--		Rage = function ()
--		end,
--		
--		return True if casting
--		IsCasting = function ()		
--		end,
--		
--		return True if player has a target
--		IsTargeting = function ()			
--		end,
--		
--		return True if player is looting.
--		IsLooting = function ()
--		end,
--}
--
--petInfo = {
--		return % health
--		Health = function () 
--		end	,
--}
--
--
--targetInfo = {
--	["maxHealth"] = 0,
--	["name"]   = nil,
--
--  return % health
--	Health = function ()
--	end,
--}
--
--function selectSelf()
--		I have to click on my portrait.  Maybe your game has a hot key or you know how to pull it off by hooking.
--end
--
--  
function boolToString (b)
	if(b==true)then
		return "True";
	else
		return "False";
	end
end

function castSkill(s)
			--print ("*** name " .. s["name"] .. " ***");
			--print ("Player Health " .. playerInfo.Health());
			--print ("Player Mana   " .. playerInfo.Mana());
			--print ("Player Rage   " .. playerInfo.Rage());
			--print ("Pet Health    " .. petInfo.Health());
			--print ("Target Health " .. targetInfo.Health());
			--
			local skillTimerExpired 		= ((deltaTime(getTime(), skillTimers[s["name"]]) > s["CoolDownSecs"] * 1000) or (skillTimers[s["name"]]==0));
			local bAbovePlayerhealth 		= (playerInfo.Health()	>= s["CastAboveHealth"]				);
			local bAbovePlayerMana 			= (playerInfo.Mana()		>= s["CastAboveMana"]					);
			local bAbovePlayerRage 			= (playerInfo.Rage()		>= s["CastAboveRage"] 				);
			local bBelowPlayerHeath			= (playerInfo.Health()	<= s["CastBelowHealth"]				);
			local bBelowPlayerMana 			= (playerInfo.Mana()		<= s["CastBelowMana"] 				);
			local bBelowPlayerRage			= (playerInfo.Rage()		<= s["CastBelowRage"] 				);
			local bAbovePetHealth 			= (petInfo.Health() 		>= s["CastAbovePetHealth"]		);
			local bBelowPetHealth 			= (petInfo.Health()			<= s["CastBelowPetHealth"]		);
			local bAboveTargetHealth 		= (targetInfo.Health()	>= s["CastAboveTargetHealth"] );
			local bBelowTargetHealth 		= (targetInfo.Health()	<= s["CastBelowTargetHealth"]	);
			local bSelfCast 						= ((s["SelfCast"] == true)	and	(window == foregroundWindow()	));
			local bCheckPlayer					= s["ValidatePlayer"];
			local bCheckPet							= s["ValidatePet"];
			local bCheckTarget					= s["ValidateTarget"];
			
			--print ("skillTimerExpired   = " .. boolToString(skillTimerExpired)    );
			--print ("bAbovePlayerhealth  = " .. boolToString(bAbovePlayerhealth)   );
			--print ("bAbovePlayerMana 	  = " .. boolToString(bAbovePlayerMana) 	  );
			--print ("bAbovePlayerRage 	  = " .. boolToString(bAbovePlayerRage) 	  );
			--print ("bBelowPlayerHeath	  = " .. boolToString(bBelowPlayerHeath)	  );
			--print ("bBelowPlayerMana 	  = " .. boolToString(bBelowPlayerMana) 	  );
			--print ("bBelowPlayerRage	  = " .. boolToString(bBelowPlayerRage)	    );
			--print ("bAbovePetHealth 	  = " .. boolToString(bAbovePetHealth) 	    );
			--print ("bBelowPetHealth 	  = " .. boolToString(bBelowPetHealth) 	    );
			--print ("bAboveTargetHealth  = " .. boolToString(bAboveTargetHealth)   );
			--print ("bBelowTargetHealth  = " .. boolToString(bBelowTargetHealth)   );
			--print ("bSelfCast 				  = " .. boolToString(bSelfCast) 				    );

			-- If all these conditions are true, cast the spell.
			if(skillTimerExpired 
					and ((bCheckPlayer == false) or
																			(bAbovePlayerhealth  
																			and bAbovePlayerMana  
																			and bAbovePlayerRage  
																			and bBelowPlayerHeath  
																			and bBelowPlayerMana
																			and bBelowPlayerRage  
																			))
					and ((bCheckPet == false) or 
																			(bAbovePetHealth 
																			and bBelowPetHealth))
					and ((bCheckTarget == false) or
																			(bAboveTargetHealth
																			and bBelowTargetHealth))
					and ((s["SelfCast"]				== false) or bSelfCast)				
					) then     
					
		
				-- self cast, create a function called selectself to selectyourself for a "SelfCast" skill.
				if(s["SelfCast"] == true)then
					selectSelf();
				end
				-- If this skill utilizes the GDC, wait until the GDC has expired.
				if(s["ObeysGDC"] == true)then
					while(deltaTime(nextCastTime , getTime()) > 0)do
						yrest(200);
					end
				end
				print("Casting  "  ..  s["name"])
				-- use the skill keys to cast.
				if(s["KeyModifyer"] > 0) and (s["Vkey"] > 0)then
					  keyboardPress( s["Vkey"], s["KeyModifyer"] )
				elseif (s["Vkey"] ~= nil) then
						keyboardPress( s["Vkey"])
				end             
				-- update the skilltimers with now.  used to identify if when the cooldown has expired
				--  If you know the memory address for cooldowns and your skills
				--  this can be removed and the large IF above adjusted to handle memory cooldown notification.
				skillTimers[s["name"]] = getTime();
				table.save( skillTimers, "./scripts/skillTimers.cfg" )
				
				nextCastTime = getTime();
				nextCastTime["low"] = nextCastTime["low"] + (s["CausesGDC"] * 25000);

				-- simple, if the cast time is not instant, lets wait until the skill has comleted casting.
				--  This is another peice of code that can be changed if you know via memory addresses
				--  about the individual skill cooldowns.  Instead of relying on the skilltimers you would
				--  instead check the memory.
				if(s["CastTime"] > 0)then
					print("more time needed " .. deltaTime(getTime(), skillTimers[s["name"]]) .. " m " .. s["CastTime"]);
					while(deltaTime(getTime(), skillTimers[s["name"]]) < s["CastTime"])do
						
						if( s["CastTime"] - deltaTime(getTime(), skillTimers[s["name"]]) > 1000)then
							yrest(1000);
						else
							yrest(s["CastTime"] - deltaTime(getTime(), skillTimers[s["name"]]));
						end
						if((s["Channeled"] == true) and playerInfo.IsCasting()==false)then  
							-- something stoped me from completing my skill. return false.
							return false;
						end
					end
					-- be nice to tell if push backs occured and need to keep sleeping until actual cast complete
				end		
				-- successfully cast the skill, return true.
				return true;
			else
				-- I did not fail casting skill, return true.  Hey, I didn't cast it either. but what the heck.			
				return true;
			end
end

-- lookup table to cross reference the string value from the xml file for keys.
-- also for bool and I set keymodifyer to 0 if it is not specified.
Lookup={
[""] = 0,
["True"] = true,
["False"] = false,
["VK_BACKSPACE"] = key.VK_BACKSPACE,
["VK_TAB"] = key.VK_TAB,
["VK_RETURN"] = key.VK_RETURN,
["VK_ENTER"] = key.VK_ENTER,
["VK_SHIFT"] = key.VK_SHIFT,
["VK_CONTROL"] = key.VK_CONTROL,
["VK_ALT"] = key.VK_ALT,
["VK_LALT"] = key.VK_LALT,
["VK_RALT"] = key.VK_RALT,
["VK_MENU"] = key.VK_MENU,
["VK_PAUSE"] = key.VK_PAUSE,
["VK_CAPITOL"] = key.VK_CAPITOL,
["VK_ESCAPE"] = key.VK_ESCAPE,
["VK_SPACE"] = key.VK_SPACE,
["VK_PAGEUP"] = key.VK_PAGEUP,
["VK_PAGEDOWN"] = key.VK_PAGEDOWN,
["VK_END"] = key.VK_END,
["VK_HOME"] = key.VK_HOME,
["VK_LEFT"] = key.VK_LEFT,
["VK_UP"] = key.VK_UP,
["VK_RIGHT"] = key.VK_RIGHT,
["VK_DOWN"] = key.VK_DOWN,
["VK_PRINT"] = key.VK_PRINT,
["VK_SNAPSHOT"] = key.VK_SNAPSHOT,
["VK_INSERT"] = key.VK_INSERT,
["VK_DELETE"] = key.VK_DELETE,
["VK_0"] = key.VK_0,
["VK_1"] = key.VK_1,
["VK_2"] = key.VK_2,
["VK_3"] = key.VK_3,
["VK_4"] = key.VK_4,
["VK_5"] = key.VK_5,
["VK_6"] = key.VK_6,
["VK_7"] = key.VK_7,
["VK_8"] = key.VK_8,
["VK_9"] = key.VK_9,
["VK_DASH"] = key.VK_DASH,
["VK_PERIOD"] = key.VK_PERIOD,
["VK_HYPHEN"] = key.VK_HYPHEN,
["VK_MINUS"] = key.VK_MINUS,
["VK_EQUAL"] = key.VK_EQUAL,
["VK_PLUS"] = key.VK_PLUS,
["VK_A"] = key.VK_A,
["VK_B"] = key.VK_B,
["VK_C"] = key.VK_C,
["VK_D"] = key.VK_D,
["VK_E"] = key.VK_E,
["VK_F"] = key.VK_F,
["VK_G"] = key.VK_G,
["VK_H"] = key.VK_H,
["VK_I"] = key.VK_I,
["VK_J"] = key.VK_J,
["VK_K"] = key.VK_K,
["VK_L"] = key.VK_L,
["VK_M"] = key.VK_M,
["VK_N"] = key.VK_N,
["VK_O"] = key.VK_O,
["VK_P"] = key.VK_P,
["VK_Q"] = key.VK_Q,
["VK_R"] = key.VK_R,
["VK_S"] = key.VK_S,
["VK_T"] = key.VK_T,
["VK_U"] = key.VK_U,
["VK_V"] = key.VK_V,
["VK_W"] = key.VK_W,
["VK_X"] = key.VK_X,
["VK_Y"] = key.VK_Y,
["VK_Z"] = key.VK_Z,
["VK_NUMPAD0"] = key.VK_NUMPAD0,
["VK_NUMPAD1"] = key.VK_NUMPAD1,
["VK_NUMPAD2"] = key.VK_NUMPAD2,
["VK_NUMPAD3"] = key.VK_NUMPAD3,
["VK_NUMPAD4"] = key.VK_NUMPAD4,
["VK_NUMPAD5"] = key.VK_NUMPAD5,
["VK_NUMPAD6"] = key.VK_NUMPAD6,
["VK_NUMPAD7"] = key.VK_NUMPAD7,
["VK_NUMPAD8"] = key.VK_NUMPAD8,
["VK_NUMPAD9"] = key.VK_NUMPAD9,
["VK_MULTIPLY"] = key.VK_MULTIPLY,
["VK_ADD"] = key.VK_ADD,
["VK_SUBTRACT"] = key.VK_SUBTRACT,
["VK_DECIMAL"] = key.VK_DECIMAL,
["VK_DIVIDE"] = key.VK_DIVIDE,
["VK_F1"] = key.VK_F1,
["VK_F2"] = key.VK_F2,
["VK_F3"] = key.VK_F3,
["VK_F4"] = key.VK_F4,
["VK_F5"] = key.VK_F5,
["VK_F6"] = key.VK_F6,
["VK_F7"] = key.VK_F7,
["VK_F8"] = key.VK_F8,
["VK_F9"] = key.VK_F9,
["VK_F10"] = key.VK_F10,
["VK_F11"] = key.VK_F11,
["VK_F12"] = key.VK_F12,
["VK_NUMLOCK"] = key.VK_NUMLOCK,
["VK_SCROLL"] = key.VK_SCROLL,
["VK_LSHIFT"] = key.VK_LSHIFT,
["VK_RSHIFT"] = key.VK_RSHIFT,
["VK_LCONTROL"] = key.VK_LCONTROL,
["VK_RCONTROL"] = key.VK_RCONTROL,
["VK_SEMICOLON"] = key.VK_SEMICOLON,
["VK_COMMA"] = key.VK_COMMA,
["VK_SLASH"] = key.VK_SLASH,
["VK_TILDE"] = key.VK_TILDE,
["VK_ACCENT"] = key.VK_ACCENT,
["VK_LBRACKET"] = key.VK_LBRACKET,
["VK_RBRACKET"] = key.VK_RBRACKET,
["VK_BACKSLASH"] = key.VK_BACKSLASH,
["VK_SINGLEQUOTE"] = key.VK_SINGLEQUOTE,
}

